import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class KeyDemo extends JFrame {
    private class DemoPanel extends JPanel
                            implements KeyListener {
        private int BOX_WIDTH = 40;
        private int x = 2;
        private int y = 2;
        public void paintComponent(Graphics g) {
            super.paintComponent(g);
            for (int i=0; i<5; i++) {
                for (int j=0; j<5; j++) {
                    if (x == i && y == j) {
                        g.fillRect(i*BOX_WIDTH,j*BOX_WIDTH,
                                   BOX_WIDTH,BOX_WIDTH);
                    } else {
                        g.drawRect(i*BOX_WIDTH,j*BOX_WIDTH,
                                   BOX_WIDTH,BOX_WIDTH);
                    }
                }
            }
        }
        public void keyPressed(KeyEvent e) {
            int k = e.getKeyCode();
            if (k == KeyEvent.VK_DOWN && y < 4) {
                y++; repaint();
            } else if (k == KeyEvent.VK_UP && 0 < y) {
                y--; repaint();
            } else if (k == KeyEvent.VK_LEFT && 0 < x) {
                x--; repaint();
            } else if (k == KeyEvent.VK_RIGHT && x < 4) {
                x++; repaint();
            }
        }
        public void keyTyped(KeyEvent e) {}
        public void keyReleased(KeyEvent e) {}
    }
    public KeyDemo() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLocation(50,50);
        DemoPanel panel = new DemoPanel();
        addKeyListener(panel);
        panel.setPreferredSize(new java.awt.Dimension(200,200));
        add(panel); pack(); setVisible(true);
    }
    public static void main(String[] args) {
        KeyDemo f = new KeyDemo();
    }
}
